// pages/expert/index.js
import {
  ajax
} from "../../utils/util";
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: []
  },
  page: 1,
  size: 10,
  total: 0,
  
  goBack(){
    wx.navigateBack();
  },
  showimge(e) {
    wx.previewImage({
      urls: [e.currentTarget.dataset.url],
    })
  },
  onChange(e) {
    const {
      list
    } = this.data;
    const item = list[e.currentTarget.dataset.index];
    ajax({
      urlType: "apiurl",
      api: "/article/audit",
      method: "post",
      data: {
        articleId: e.currentTarget.dataset.id,
        ok: e.detail
      }
    }).then(res => {
      if (res.code !== 0) return wx.showToast({
        title: res.message || '网络波动',
        icon: "none"
      })
      item.auditType = e.detail ? "ExpertReview" : "ExpertReject";
      this.setData({
        list
      })
    })
  },
  getData() {
    ajax({
      urlType: "apiurl",
      api: "/article/list-audit",
      method: "post",
      data: {
        page: this.page,
        size: this.size
      }
    }).then(res => {
      if (res.code !== 0) return wx.showToast({
        title: '请求失败',
        icon: "none"
      })
      const data = res.data || {};
      data.data.length && (this.page += 1);
      this.total = data.total;
      this.setData({
        list: [...this.data.list, ...data.data]
      })
    })
  },

  scrollbottom() {
    this.getData();
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.getData();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    return {
      title: __wxConfig.accountInfo.nickname,
      path: "/pages/index/index"
    }
  }
})