// pages/login/index.js
import {
  ajax
} from "../../utils/util";
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userUrl: wx.getStorageSync('userUrl') || "",
    phone: wx.getStorageSync('phone') || false
  },

  chooseavatar(e) {
    wx.setStorageSync('userUrl', e.detail.avatarUrl)
    this.setData({
      userUrl: e.detail.avatarUrl,
    })
  },

  getphone(e) {
    ajax({
      urlType: "apiurl",
      api: "/wx/getuserphonenumber?code=" + e.detail.code
    }).then(res => {
      if (res.code !== 0) return wx.showToast({
        title: res.message || '请求失败',
        icon: 'none'
      })
      wx.setStorageSync('token', res.data.token);
      wx.setStorageSync('userGroup', res.data.userGroup);
      wx.setStorageSync('phone', res.data.phoneInfo.phoneNumber);
      this.setData({
        phone: res.data.phoneInfo.phoneNumber
      })
    })
  },

  submit() {
    const { phone, userUrl } = this.data;
    if(!phone || !userUrl) return wx.showToast({
      title: '请获取手机号或头像',
      icon: 'none'
    })
    wx.showLoading({
      title: '登录中',
    });
    const t = setTimeout(() => {
      clearTimeout(t);
      wx.hideLoading();
      wx.switchTab({
        url: this.backUrl,
      })
    }, 300);
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    options.backurl && (this.backUrl = '/' + options.backurl);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})