// pages/userData/index.js
import {
  ajax
} from "../../utils/util";
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: [],
    value: ""
  },
  list: [],
  phone: wx.getStorageSync('phone') || '',
  change(e) {
    const rex = new RegExp(e.detail);
    const li = [];
    for (let i = 0; i < this.list.length; i++) {
      const v = this.list[i];
      let isShow = false;
      const keys = ["area", "articleDescribe", "articleGroup", "articleName", "birthday", "name", "phone", "school", "teacher", "teacherPhone"];
      for (let o = 0; o < keys.length; o++) {
        if (rex.test(v[keys[o]])) isShow = true;
      }
      if (!e.detail) isShow = true
      if (isShow) li.push(v);
    }
    this.setData({
      list: li
    })
  },

  modify(e) {
    const {
      list
    } = this.data;
    const item = list[e.currentTarget.dataset.index];
    wx.navigateTo({
      url: '/pages/modify/index?data=' + JSON.stringify(item)
    })
  },

  delet(e) {
    const {
      list
    } = this.data;
    const item = list[e.currentTarget.dataset.index];
    wx.showModal({
      title: '删除',
      content: '确定删除' + item.articleName + '？',
      complete: (res) => {
        if (res.confirm) {
          ajax({
            urlType: "apiurl",
            api: "/article/delete?articleId=" + item.id,
          }).then(res => {
            if (res.code !== 0) {
              wx.showToast({
                title: res.message || '网络波动',
                icon: "none"
              })
              return
            }
            list.splice(e.currentTarget.dataset.index, 1)
            this.setData({
              list
            })
          })
        }
      }
    })
  },

  init() {
    ajax({
      urlType: "apiurl",
      api: "/article/list",
    }).then(res => {
      if (res.code !== 0) return wx.showToast({
        title: res.message || '请求失败',
        icon: 'none'
      })
      const li = res.data || [];
      this.list = li;
      this.setData({
        list: li
      })
    })
  },

  goBack(){
    wx.navigateBack();
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.init();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    this.init();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    return {
      title: __wxConfig.accountInfo.nickname,
      path: "/pages/index/index"
    }
  }
})